<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:variable name="allow_commands" select="//playlist/@allow_commands"/>
<xsl:variable name="allow_files" select="//playlist/@allow_files"/>
<xsl:template match="playlist">
<html>
<head>
	<title>empeg web lite - <xsl:value-of select="@title"/></title>
	<script type="text/javascript" language="javascript">
	// <![CDATA[
		var FID = "";

		function httpGetRequest(url, xml, callback) {
			if (window.XMLHttpRequest)
				var xmlhttp = new XMLHttpRequest();
			else if (window.ActiveXObject)
				var xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
			xmlhttp.open("GET", url, true);
			xmlhttp.onreadystatechange = function() {
				if(xmlhttp.readyState != 4) return;
				if(callback != null) callback(xml ? xmlhttp.responseXML : xmlhttp.responseText);
			};
			xmlhttp.send(null);
		}

		function doCommand(command) {
			httpGetRequest("/?NODATA&" + command, false, null);
			return false;
		}

		var png4msie = false;
		try {
			var png4msie = navigator.platform == "Win32" && navigator.appName == "Microsoft Internet Explorer";
			if (png4msie) {
				png4msie = false;
				var match = navigator.appVersion.match(/MSIE (\d+\.\d+)/, '');
				if (match) {
					var version = parseInt(match[1]);
					png4msie = (version >= 5.5) && (version < 7);
				}
			}
		} catch(e) {}

		function fixPNG(myImage, fallback) {
			myImage.onload = null;
			myImage.png4msie = false;
			if (png4msie) {
				try {
					if (document.body.filters) {
						myImage.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+myImage.src+"',sizingMethod='scale')";
						myImage.src = 'empty.gif';
						myImage.png4msie = true;
					} else {
						myImage.src = fallback;
					}
				} catch (e) {
					myImage.src = fallback;
				}
			}
		}

		var VFDcount = 0, pressed = 0, rButton = "", tRepeat = 150, iVFD, tVFD = 125, loadingVFD = 0;

		function ignore() {
			return false;
		}

		function pressButton(button) {
			if (!pressed) {
				pressed = 1;
				httpGetRequest("/?NODATA&BUTTONRAW=" + button, false, null);
			}
			return false;
		}

		function releaseButton(button) {
			if (pressed) {
				pressed = 0;
				httpGetRequest("/?NODATA&BUTTONRAW=" + button + ".R", false, null);
			}
			stopRepeat();
			return false;
		}

		function repeatButton() {
			if (rButton) {
				pressed = 0;
				pressButton(rButton);
				setTimeout('repeatButton()', tRepeat);
			}
		}

		function startRepeat(button,interval) {
			if (!rButton) {
				rButton = button;
				tRepeat = interval;
				repeatButton();
			}
			return false;
		}

		function stopRepeat() {
			if (rButton) {
				rButton = "";
				pressed = 0;
			}
			return false;
		}

		function initVFD() {
			iVFD = setInterval("refreshVFD()",tVFD);
			document.onkeydown = keydown;
			document.onkeyup = keyup;
		}

		function doneVFD() {
			loadingVFD = 0;
		}

		function failVFD() {
			clearInterval(iVFD);
		}

		function refreshVFD() {
			if (loadingVFD == 0) {
				loadingVFD = 1000 / tVFD;
				document.images.vfd.src = '/proc/empeg_screen.png?IGNORE=' + Date() + VFDcount++;
				document.images.vfd.onload  = doneVFD;
				document.images.vfd.onabort = doneVFD;
				document.images.vfd.onerror = failVFD;
			} else {
				--loadingVFD;
			}
		}

		function keydown(e) {
			var key = null;
			if (e==undefined) {
				key = window.event.keyCode;
			}else{
				key = e.which;
			}
			switch (key) {
				case 33: // Page Up
					return startRepeat('KnobRight',125);
				case 34: // Page Down
					return startRepeat('KnobLeft',125);
				case 12: // 5
				case 35: // Pos 1
				case 36: // End
					return pressButton('Knob');
				case 37: // Left
					return pressButton('Left');
				case 38: // Up
					return pressButton('Top');
				case 39: // Right
					return pressButton('Right');
				case 40: // Down
					return pressButton('Bottom');
			}
			return true;
		}
		function keyup(e) {
			var key = null;
			if (e==undefined) {
				key = window.event.keyCode;
			}else{
				key = e.which;
			}
			switch (key) {
				case 33:
					return stopRepeat();
				case 34:
					return stopRepeat();
				case 12:
				case 35:
				case 36:
					return releaseButton('Knob');
				case 37:
					return releaseButton('Left');
				case 38:
					return releaseButton('Top');
				case 39:
					return releaseButton('Right');
				case 40:
					return releaseButton('Bottom');
			}
			return true;
		}

		function defSort(a, b) {
			return a<b?-1:a>b;
		}
		function parseNum(v) {
			if (v.indexOf('/') != -1) { // tracknumber with tracktotal
				v = v.split('/');
				return parseInt(v[0],10)*1000000 + parseInt(v[1],10);
			} else if (v.indexOf(':') != -1) { // time
				v = v.split(':');
				return parseInt(v[0],10)*60 + parseInt(v[1],10);
			} else { // playlist-length or tracknumber without tracktotal
				return parseInt(v,10)-1000000;
			}
		}
		function numSort(a, b) {
			a = parseNum(a);
			b = parseNum(b);
			return a<b?-1:a>b;
		}

		var sortRows = null, sortInsert = null, sortColumns = null, sortDirection = null;
		var sortFunctions = {
			'artist'	: defSort,
			'playlist'	: defSort,
			'source'	: defSort,
			'title'		: defSort,
			'tracknr'	: numSort,
			'duration'	: numSort,
			'length'	: numSort
		}

		function getText(obj) {
			var res = '';
			for (var i=0; i<obj.childNodes.length; i++) {
				var child = obj.childNodes[i];
				if (child.nodeType == 3) {
					res += child.nodeValue;
				} else if (child.nodeType == 1) {
					res += ' '+getText(child);
				}
			}
			return res.replace(/(^ +| +$)/,'').replace(/ +/,' ');
		}
		function getColumn(row, names) {
			var res = row.cache[names[0]];
			if (!res) {
				var first = true;
				for (var c=0; c<row.cells.length; c++) {
					if (first && sortFunctions[row.cells[c].className]) {
						first = false;
						res = Array(-1000000, row.cells[c].className, getText(row.cells[c]));
					}
					for (var n=0; n<names.length; n++)
						if (row.cells[c].className == names[n]) {
							res = Array(-n, names[n], getText(row.cells[c]));
							break;
						}
				}
				row.cache[names[0]] = res;
			}
			return res;
		}

		function rowSort(ra, rb) {
			var ca = getColumn(ra, sortColumns);
			var cb = getColumn(rb, sortColumns);
			if (ca[1] == cb[1]) {
				return sortFunctions[ca[1]](ca[2], cb[2]);
			} else {
				return defSort(ca[0], cb[0]);
			}
		}

		function doSort(obj /*, column, column, ... */) {
			if (sortRows === null) {
				sortRows = Array();
				var table = document.getElementById('playlists');
				for (var r=0; r<table.rows.length; r++) {
					if (table.rows[r].parentNode.nodeName == 'THEAD') continue;
					var line = table.rows[r].className;
					if (line=='on' || line == 'off') {
						table.rows[r].cache = {};
						sortRows[sortRows.length] = table.rows[r];
					} else {
						sortInsert = table.rows[r];
						break;
					}
				}
			}

			var columns = Array();
			for (var c=1; c<arguments.length; c++)
				columns[c-1] = arguments[c];

			if (sortColumns && columns[0] == sortColumns[0]) {
				sortDirection = !sortDirection;
				sortRows.reverse();
			} else {
				sortColumns = columns;
				sortDirection = true;
				sortRows.sort(rowSort);
			}

			for (var r=0; r<sortRows.length; r++) {
				sortInsert.parentNode.insertBefore(sortRows[r], sortInsert);
				sortRows[r].className = r%2?'on':'off';
			}

			for (var node=obj.parentNode.firstChild; node; node=node.nextSibling)
				node.innerHTML = node.innerHTML.replace(/ [^ ]+$/,'');
			obj.innerHTML += sortDirection?' &darr;':' &uarr;';
		}

		function selectFascia(select) {
			var myImage = document.getElementById('fascia');
			var newSource = select.options[select.selectedIndex].value;
			if (myImage.png4msie) {
				if (newSource.indexOf('.png')==-1) {
					myImage.style.filter = null;
					myImage.src = newSource;
				} else {
					myImage.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+newSource+"',sizingMethod='scale')";
					myImage.src = 'empty.gif';
				}
			} else {
				myImage.src = newSource;
			}
		}

	// ]]>
	</script>
	<style type="text/css">
	/* <![CDATA[ */
		/* --- global styles ------------------------------------------*/
		body			{	margin: 8px;
						padding: 0px;			}
		div			{	margin: 0px;
						padding: 0px;			}

		/* --- empeg fascia image styles ------------------------------*/
		div.fascia		{	position: relative;
						top: -127px;
						left: 5px;			}

		select.fascia		{	position: absolute;
						width: 150px;
						height: 172px;
						border: 1px solid #888;
						top: 13px;
						left: 598px;			}

		.screen			{	position: relative;
						background: #000;
						width: 532px;
						height: 132px;
						top: 25px;
						left: 25px;			}

		#screen			{	position: relative;
						top: 33px;
						left: 142px;			}

		#playlists		{	position: relative;
						top: -127px;			}

		/* --- table styles -------------------------------------------*/
		table			{	font-family: verdana;
						font-size: 13px;
						border: 0px solid #888;
						border-collapse: collapse;	}
		tr.on 			{	background: #e0e0e0		}
		tr.off 			{	background: #fff;		}
		th 			{	border: 1px solid #888;
						background: #57a;
						color: #ddd;
						padding: 4px;
						cursor: default;
						text-align: left;		}
		th.title 		{	background: #555;
						color: #ddd;
						font-size: 18px;		}
		th.action		{	cursor: pointer;		}
		td 			{	border: 1px solid #888;
						padding: 4px;			}
		td.footer 		{	background: #555;
						color: #ddd;
						font-size: 10px;
						padding: 3px 4px 3px 4px;	}
		td.playlist 		{	font-weight: bold;		}
		td.tracknr		{	text-align: right;		}
		td.length, td.duration	{	text-align: right;		}
		td.actions 		{	font-size: 10px;
						font-weight: bold;
						background: #bbb;
						color: #777;			}
		tr.off td.actions 	{	background: #ddd;		}
		td.actions span.bullet 	{	margin-left: 4px;
						margin-right: 4px;		}

		/* --- misc styles ------------------------------------------- */
		span.control 		{	font-size: 12px;
						padding: 0px 0px 0px 10px;	}
		span#footerlinks	{	float: left;
						text-align: left;		}
		span#tagline		{	float: right;
						text-align: right;		}

		/* --- link styles ------------------------------------------- */
		.actions a,
		.actions a:link,
		.actions a:visited,
		.actions a:active 	{	color: #777;
						text-decoration: none;
						padding: 4px;			}
		.actions a:hover 	{	background-color: #57a;
						text-decoration: none;
						color: #fff;			}
		span.control a,
		span.control a:link,
		span.control a:visited,
		span.control a:active 	{	color: #368;
						font-weight: bold;
						text-decoration: none;
						padding: 2px 3px 4px 3px;	}
		span.control a:hover 	{	background-color: #57a;
						text-decoration: none;
						color: #fff;			}
		a,
		a:link,
		a:visited,
		a:active 		{	color: #368;
						text-decoration: none;
						padding: 2px;			}
		a:hover 		{	background-color: #57a;
						text-decoration: none;
						color: #fff;			}
		#footerlinks a,
		#tagline a,
		#footerlinks a:link,
		#tagline a:link,
		#footerlinks a:visited,
		#tagline a:visited,
		#footerlinks a:active,
		#tagline a:active	{	color: #ddd;
						font-size: 10px;
						text-decoration: none;
						padding: 1px;			}
		#tagline a:hover,
		#footerlinks a:hover 	{	background-color: #ddd;
						text-decoration: none;
						color: #333;			}
	/* ]]> */
	</style>
</head>
<body onload="initVFD()">
	<div class="screen">
		<img id="screen" src="/proc/empeg_screen.png" name="vfd" width="256" height="64" />
	</div>
	<div class="fascia">
		<xsl:choose>
			<xsl:when test="$allow_commands = 1">
				<map id="buttons" name="buttons">
					<area shape="circle" coords="80,53 10"
						       href="/?NODATA"
						    onclick="return ignore()"
						onmousedown="return pressButton('Top')"
						  onmouseup="return releaseButton('Top')"
						 onmouseout="return releaseButton('Top')" />
					<area shape="polygon" coords="39,89 48,77 77,72 77,97 70,101 51,98"
						       href="/?NODATA"
						    onclick="return ignore()"
						onmousedown="return pressButton('Left')"
						  onmouseup="return releaseButton('Left')"
						 onmouseout="return releaseButton('Left')" />
					<area shape="polygon" coords="84,72 111,76 123,87 112,96 91,101 84,96"
						       href="/?NODATA"
						    onclick="return ignore()"
						onmousedown="return pressButton('Right')"
						  onmouseup="return releaseButton('Right')"
						 onmouseout="return releaseButton('Right')" />
					<area shape="polygon" coords="81,103 89,108 93,107 90,126 81,144 71,128 69,107 72,107"
						       href="/?NODATA"
						    onclick="return ignore()"
						onmousedown="return pressButton('Bottom')"
						  onmouseup="return releaseButton('Bottom')"
						 onmouseout="return releaseButton('Bottom')" />
					<area shape="circle"  coords="476,104 14"
						       href="/?NODATA"
						    onclick="return ignore()"
						onmousedown="return pressButton('Knob')"
						  onmouseup="return releaseButton('Knob')"
						 onmouseout="return releaseButton('Knob')" />
					<area shape="polygon" coords="467,83 461,88 456,94 454,102 456,111 460,117 466,122 463,129 454,124 447,115 444,103 447,88 454,80 463,75"
						       href="/?NODATA"
						    onclick="return ignore()"
						onmousedown="return startRepeat('KnobLeft',300)"
						  onmouseup="return stopRepeat()"
						 onmouseout="return stopRepeat()" />
					<area shape="polygon" coords="483,84 490,88 494,94 496,102 495,111 491,117 485,121 488,128 496,124 502,114 504,102 502,90 496,82 487,76"
						       href="/?NODATA"
						    onclick="return ignore()"
						onmousedown="return startRepeat('KnobRight',300)"
						  onmouseup="return stopRepeat()"
						 onmouseout="return stopRepeat()" />
				</map>
				<img id="fascia" src="fascia.png" width="572" height="172" onload="fixPNG(this,'fascia.gif')" usemap="#buttons" border="0"/>
			</xsl:when>
			<xsl:when test="$allow_commands = 0">
				<img id="fascia" src="fascia.png" width="572" height="172" onload="fixPNG(this,'fascia.gif')" border="0"/>
			</xsl:when>
		</xsl:choose>
	</div>
	<select class="fascia" size="9" onchange="selectFascia(this)">
		<option value="fascia.png" selected="selected">Default</option>
		<option value="fascia_amber.png">Amber</option>
		<option value="fascia_blue.png">Blue</option>
		<option value="fascia_green.png">Green</option>
		<option value="fascia_red.png">Red</option>
		<option value="fascia_crystal.png">Crystal</option>
		<option value="fascia_stealth.png">Stealth</option>
		<option value="fascia_lit_amber.png">Amber (Lights)</option>
		<option value="fascia_lit_blue.png">Blue (Lights)</option>
		<option value="fascia_lit_green.png">Green (Lights)</option>
		<option value="fascia_lit_red.png">Red (Lights)</option>
		<option value="fascia_lit_smoke.png">Smoke (Lights)</option>
		<option value="fascia.gif">Fallback (gif)</option>
	</select>
	<br clear="all"/>
	<table id="playlists">
		<thead>
			<tr>
				<th class="title">
					<xsl:attribute name="colspan"><xsl:value-of select="5 + ($allow_commands * 2) + $allow_files"/></xsl:attribute>
					<xsl:value-of select="@title"/>
				</th>
			</tr>
			<tr>
				<xsl:choose><xsl:when test="$allow_commands = 1">
					<th class="action"/>
				</xsl:when></xsl:choose>
				<th class="action" title="Sort by Artist" onclick="doSort(this,'artist','playlist')">Artist</th>
				<th class="action" title="Sort by Source" onclick="doSort(this,'source')">Source</th>
				<th class="action" title="Sort by Title" onclick="doSort(this,'title')">Title</th>
				<th class="action" title="Sort by Track" onclick="doSort(this,'tracknr')">Track</th>
				<th class="action" title="Sort by Length" onclick="doSort(this,'duration','length')">Length</th>
				<xsl:choose><xsl:when test="($allow_commands = 1) or ($allow_files = 1)">
					<th><xsl:attribute name="colspan"><xsl:value-of select="$allow_files + $allow_commands"/></xsl:attribute>Actions</th>
				</xsl:when></xsl:choose>
			</tr>
		</thead>
		<tbody>
			<xsl:apply-templates select="items"/>
			<tr><td class="footer">
					<xsl:attribute name="colspan"><xsl:value-of select="5 + ($allow_commands * 2) + $allow_files"/></xsl:attribute>
					<span id="footerlinks"><a href="/?FID=101&amp;EXT=.xml">root playlist</a></span>
					<span id="tagline"><a href="http://cushman.net/projects/ewl/">empeg web lite 0.10</a></span>
			</td></tr>
		</tbody>
	</table>
</body>
</html>
</xsl:template>
<xsl:template match="items">
	<xsl:for-each select="item">
	<tr>
		<xsl:attribute name="class">
			<xsl:choose>
				<xsl:when test="(position() mod 2 = 0)">on</xsl:when>
				<xsl:when test="(position() mod 2 = 1)">off</xsl:when>
			</xsl:choose>
		</xsl:attribute>
		<xsl:choose>
			<xsl:when test="$allow_commands = 1">
				<td class="actions">
					<a><xsl:attribute name="href">/?NODATA&amp;SERIAL=%23<xsl:value-of select="fid"/></xsl:attribute>
					<xsl:attribute name="onclick">return doCommand('SERIAL=%23<xsl:value-of select="fid"/>')</xsl:attribute>
					<xsl:attribute name="title">Play</xsl:attribute>play</a>
				</td>
			</xsl:when>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="type = 'playlist'">
				<td class="playlist" colspan="4">
					<a><xsl:attribute name="href">/?FID=<xsl:value-of select="tagfid"/>&amp;EXT=.xml</xsl:attribute>
					<xsl:value-of select="title"/></a></td>
				<td class="length"><xsl:value-of select="length"/></td>
			</xsl:when>
			<xsl:when test="type = 'tune'">
				<td class="artist"><xsl:value-of select="artist"/></td>
				<td class="source"><xsl:value-of select="source"/></td>
				<td class="title"><xsl:value-of select="title"/></td>
				<td class="tracknr"><xsl:value-of select="tracknr"/></td>
				<td class="duration"><xsl:value-of select="duration"/></td>
			</xsl:when>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="$allow_commands = 1">
				<td class="actions">
					<a><xsl:attribute name="href">/?NODATA&amp;SERIAL=%23<xsl:value-of select="fid"/>%2B</xsl:attribute>
					<xsl:attribute name="onclick">return doCommand('SERIAL=%23<xsl:value-of select="fid"/>%2B')</xsl:attribute>
					<xsl:attribute name="title">Append</xsl:attribute>app</a>
					<a><xsl:attribute name="href">/?NODATA&amp;SERIAL=%23<xsl:value-of select="fid"/>!</xsl:attribute>
					<xsl:attribute name="onclick">return doCommand('SERIAL=%23<xsl:value-of select="fid"/>!')</xsl:attribute>
					<xsl:attribute name="title">Insert</xsl:attribute>ins</a>
					<a><xsl:attribute name="href">/?NODATA&amp;SERIAL=%23<xsl:value-of select="fid"/>-</xsl:attribute>
					<xsl:attribute name="onclick">return doCommand('SERIAL=%23<xsl:value-of select="fid"/>-')</xsl:attribute>
					<xsl:attribute name="title">Enqueue</xsl:attribute>enq</a>
				</td>
			</xsl:when>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="$allow_files = 1">
				<td class="actions">
					<a><xsl:attribute name="href">/
						<xsl:value-of select="translate(title, ' ', '_')"/>.m3u?FID=
						<xsl:value-of select="tagfid"/>&amp;EXT=.m3u
						</xsl:attribute>
					<xsl:attribute name="title">Stream </xsl:attribute>
					<xsl:choose>
						<xsl:when test="$allow_commands = 1">strm</xsl:when>
						<xsl:otherwise>strm</xsl:otherwise>
					</xsl:choose></a>
					<xsl:choose>
						<xsl:when test="(type = 'tune')">
							<a><xsl:attribute name="href">/
								<xsl:value-of select="translate(artist, ' ', '_')"/>-
								<xsl:value-of select="translate(title, ' ', '_')"/>.mp3?FID=
								<xsl:value-of select="fid"/>&amp;EXT=.mp3
								</xsl:attribute>
							<xsl:attribute name="title">Save File Locally </xsl:attribute>
							<xsl:choose>
								<xsl:when test="$allow_commands = 1">save</xsl:when>
								<xsl:otherwise>save</xsl:otherwise>
							</xsl:choose></a>
						</xsl:when>
					</xsl:choose>
				</td>
			</xsl:when>
		</xsl:choose>
	</tr>
	</xsl:for-each>
</xsl:template>
</xsl:stylesheet>
